#include <windows.h>
#include "stdafx.h"
#include "foo.h"
#include "cell.h"
#include "myObj.h"
#include <fstream>



int myObjClass::WriteScript( char* fileName ){
	
	
	std::fstream fout( fileName, std::ios::out | std::ios::binary );
	fout << "xNum = " << xNum << std::endl
		<< "yNum = " << yNum << std::endl
		<< std::endl
		<< "funcArray = {}" << std::endl
		<< "for i = 1, xNum do" << std::endl
		<< "	funcArray[ i ] = {}" << std::endl
		<< "	for j = 1, yNum do" << std::endl
		<< "		funcArray[ i ][ j ] = {}" << std::endl
		<< "	end" << std::endl
		<< "end" << std::endl
		<< std::endl;
	
	int xCounter;
	int yCounter;
	for( yCounter = 0; yCounter < yNum; ++yCounter ){
		for( xCounter = 0; xCounter < xNum; ++xCounter ){
			fout << std::endl
				 << "funcArray[ " << xCounter + 1 << " ][ " << yCounter + 1 << " ].func = function()" << std::endl;
			fout.write( cell[ xCounter ][ yCounter ]->buf, strlen( cell[ xCounter ][ yCounter ]->buf ) );
			fout << std::endl
				 << "end" << std::endl;
			fout << "funcArray[ " << xCounter + 1 << " ][ " << yCounter + 1 << " ].xNextTrue = ";
			switch( cell[ xCounter ][ yCounter ]->tDest ){
			//xCounter, yCounter+1
			case 1: fout << xCounter << std::endl; break;
			case 4: fout << xCounter << std::endl; break;
			case 7: fout << xCounter << std::endl; break;
			case 3: fout << xCounter + 2 << std::endl; break;
			case 6: fout << xCounter + 2 << std::endl; break;
			case 9: fout << xCounter + 2 << std::endl; break;
			default : fout << xCounter + 1 << std::endl; break;
			}
			fout << "funcArray[ " << xCounter + 1 << " ][ " << yCounter + 1 << " ].yNextTrue = ";
			switch( cell[ xCounter ][ yCounter ]->tDest ){
			case 1: fout << xCounter + 2 << std::endl; break;
			case 2: fout << xCounter + 2 << std::endl; break;
			case 3: fout << xCounter + 2 << std::endl; break;
			case 7: fout << xCounter << std::endl; break;
			case 8: fout << xCounter << std::endl; break;
			case 9: fout << xCounter << std::endl; break;
			default : fout << xCounter + 1 << std::endl; break;
			}
			fout << "funcArray[ " << xCounter + 1 << " ][ " << yCounter + 1 << " ].xNextFalse = ";
			switch( cell[ xCounter ][ yCounter ]->fDest ){
			case 1: fout << xCounter << std::endl; break;
			case 4: fout << xCounter << std::endl; break;
			case 7: fout << xCounter << std::endl; break;
			case 3: fout << xCounter + 2 << std::endl; break;
			case 6: fout << xCounter + 2 << std::endl; break;
			case 9: fout << xCounter + 2 << std::endl; break;
			default : fout << xCounter + 1 << std::endl; break;
			}
			fout << "funcArray[ " << xCounter + 1 << " ][ " << yCounter + 1 << " ].yNextFalse = ";
			switch( cell[ xCounter ][ yCounter ]->fDest ){
			case 1: fout << xCounter + 2 << std::endl; break;
			case 2: fout << xCounter + 2 << std::endl; break;
			case 3: fout << xCounter + 2 << std::endl; break;
			case 7: fout << xCounter << std::endl; break;
			case 8: fout << xCounter << std::endl; break;
			case 9: fout << xCounter << std::endl; break;
			default : fout << xCounter + 1 << std::endl; break;
			}
		}
	}
	fout << std::endl << std::endl
		<< "function step( x, y )" << std::endl
		<< "	if funcArray[ x ][ y ].func() then" << std::endl
		<< "		return funcArray[ x ][ y ].xNextTrue, funcArray[ x ][ y ].yNextTrue" << std::endl
		<< "	else" << std::endl
		<< "		return funcArray[ x ][ y ].xNextFalse, funcArray[ x ][ y ].yNextFalse" << std::endl
		<< "	end" << std::endl
		<< "end" << std::endl
		<< std::endl << std::endl
		<< "function main()" << std::endl
		<< "	xNow = 1" << std::endl
		<< "	yNow = 1" << std::endl
		<< "	while true do" << std::endl
		<< "		xNext, yNext = step( xNow, yNow )" << std::endl
		<< "		yield()" << std::endl
		<< "		if xNext > xNum or yNext > yNum or xNext <= 0 or yNext <= 0 then" << std::endl
		<< "			xNext = 1" << std::endl
		<< "			yNext = 1" << std::endl
		<< "		end" << std::endl
		<< "		xNow = xNext" << std::endl
		<< "		yNow = yNext" << std::endl
		<< "	end" << std::endl
		<< "end" << std::endl << std::endl;
	return 0;
}





myObjClass::myObjClass( int xPara, int yPara ){
	xNum = xPara;
	yNum = yPara;
	cell = new cellClass**[ xNum ];
	for( int i = 0;	i < xNum; ++i ){
		cell[ i ] = new cellClass*[ yNum ];
	}
	
	
	now = NULL;
	
	int CounterX;
	int CounterY;
	int menuID = 1000;
	
	for( CounterY = 0; CounterY < yNum; CounterY++ ){
		for( CounterX = 0; CounterX < xNum; CounterX++ ){
			cell[ CounterX ][ CounterY ] = new cellClass( menuID );
			menuID++;
		}
	}
}

int myObjClass::CreateInterface( HWND hMainWnd ){
	int CounterX;
	int CounterY;
	
	for( CounterX = 0; CounterX < xNum; CounterX++ ){
		for( CounterY = 0; CounterY < yNum; CounterY++ ){
			cell[ CounterX ][ CounterY ]->CreateInterface( hMainWnd, 90 * CounterX + 40, 90 * CounterY + 40 );
		}
	}
	
	return 0;
}

bool myObjClass::isMyObj( int ID ){
	if( ID < 1000 ) return false;
	
	int CounterX;
	int CounterY;
	
	for( CounterX = 0; CounterX < xNum; CounterX++ ){
		for( CounterY = 0; CounterY < yNum; CounterY++ ){
			if( cell[ CounterX ][ CounterY ]->menuID == ID ){
				return true;
			}
		}
	}
	
	return false;
}


int myObjClass::SaveText( HWND hEdit ){
	if( now ){
		now->SaveText( hEdit );
	}
	return 0;
}

int myObjClass::ChangeText( HWND hEdit, int ID ){
	if( now ){
		now->SaveText( hEdit );
	}
	ShowText( hEdit, ID );
	
	return 0;
}

int myObjClass::ShowText( HWND hEdit, int ID ){
	if( ID < 1000 ) return 1;
	
	int CounterX;
	int CounterY;
	
	//numXȂǂ犄oقCH
	for( CounterX = 0; CounterX < xNum; CounterX++ ){
		for( CounterY = 0; CounterY < yNum; CounterY++ ){
			if( cell[ CounterX ][ CounterY ]->menuID == ID ){
				cell[ CounterX ][ CounterY ]->ShowText( hEdit );
				now = cell[ CounterX ][ CounterY ];
				return 0;
			}
		}
	}
	return 1;
}

int myObjClass::Reflesh( HWND hMainWnd ){
	//{^EeLXg̍ĕ\Ȃ
	
	
	return 0;
}

int myObjClass::Write( char* fileName ){
	std::fstream fout( fileName, std::ios::out | std::ios::binary );
	WORD fBuf[100];
	fBuf[0] = xNum;
	fBuf[1] = yNum;
	int Counter = 2;
	int xCounter;
	int yCounter;
	for( yCounter = 0; yCounter < yNum; ++yCounter ){
		for( xCounter = 0; xCounter < xNum; ++xCounter ){
			fBuf[ Counter ] = strlen( cell[ xCounter ][ yCounter ]->buf );
			Counter++;
		}
	}
	fout.write( (char*)fBuf, ( 2 + xNum * yNum ) * 2 );
	
	for( yCounter = 0; yCounter < yNum; ++yCounter ){
		for( xCounter = 0; xCounter < xNum; ++xCounter ){
			fout.write( cell[ xCounter ][ yCounter ]->buf, strlen( cell[ xCounter ][ yCounter ]->buf ) );
		}
	}
	
	return 0;
}

int myObjClass::Read( char* fileName ){
	std::fstream fin( fileName, std::ios::in | std::ios::binary );
	WORD xNumRead;
	WORD yNumRead;
	fin.read( (char*)&xNumRead, 2 );
	fin.read( (char*)&yNumRead, 2 );
	
	int xCounter;
	int yCounter;
	
	//newɂ
	WORD size[ field_x_num ][ field_y_num ];
	for( yCounter = 0; yCounter < yNum; ++yCounter ){
		for( xCounter = 0; xCounter < xNum; ++xCounter ){
			fin.read( (char*)&size[ xCounter ][ yCounter ], 2 );
		}
	}
	for( yCounter = 0; yCounter < yNum; ++yCounter ){
		for( xCounter = 0; xCounter < xNum; ++xCounter ){
			fin.read( cell[ xCounter ][ yCounter ]->buf, size[ xCounter ][ yCounter ] );
		}
	}
	ShowText( hEdit, 1000 );
	
//	MessageBox(hMainWnd, fileName, TEXT( "debug" ), MB_OKCANCEL);
	
	
	return 0;
}

int myObjClass::init( HWND hMainWnd ){
	int xCounter;
	int yCounter;
	for( yCounter = 0; yCounter < yNum; ++yCounter ){
		for( xCounter = 0; xCounter < xNum; ++xCounter ){
			memset( cell[ xCounter ][ yCounter ]->buf, 0, buf_size );
		}
	}
	Edit_SetText(hEdit, "" );
	
	return 0;
}
